routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ArticlesController;

Route::get('/', function () {
    return view('welcome');
})->name('root');

// 文章分享
Route::resource('/articles', ArticlesController::class);
Route::get('/articles/admin', [ArticlesController::class, 'index'])->name('articles.admin');
Route::get('/articles', [ArticlesController::class, 'index'])->name('articles');

// Livewire: Shopping
Route::get('/prods', App\Http\Livewire\Admin\ProdIndex::class)->name('prods');
Route::get('/prods/create', App\Http\Livewire\Admin\ProdCreate::class)->name('prods.create');
Route::get('/prods/{prod_id}', App\Http\Livewire\Admin\ProdView::class)->name('prods.view');
Route::get('/prods/{prod_id}/edit', App\Http\Livewire\Admin\ProdEdit::class)->name('prods.edit');

// Livewire: 文章分享
Route::get('/lw/articles', App\Http\Livewire\Articles\Index::class)->name('lw.articles');
Route::get('/lw/articles/admin', App\Http\Livewire\Articles\Index::class)->name('lw.articles.admin')->middleware('auth');
Route::get('/lw/articles/create', App\Http\Livewire\Articles\Create::class)->name('lw.articles.create')->middleware('auth');
Route::get('/lw/articles/{id}/edit', App\Http\Livewire\Articles\Edit::class)->name('lw.articles.edit')->middleware('auth');
Route::get('/lw/articles/{id}', App\Http\Livewire\Articles\Show::class)->name('lw.articles.show');

Route::middleware([
    'auth:sanctum',
    config('jetstream.auth_session'),
    'verified'
])->group(function () {
    Route::get('/dashboard', function () {
        return redirect()->route('articles');
        // return view('dashboard');
    })->name('dashboard');
});

app/Models/Article.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Article extends Model
{
    use HasFactory;
    use SoftDeletes;

    protected $fillable = ['title', 'content', 'state', 'parent_id'];

    public function user() {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/ArticlesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use App\Models\Article;
use App\Http\Requests\ArticleRequest;

class ArticlesController extends Controller
{
    public function __construct() {
        $this->middleware('auth')->except(['index', 'show']);
    }

    public function index(Request $request) {
        session(['redirect_url' => $request->path()]);

        $perpage_cnt = 10;

        if ($request->route()->getName() == 'articles.admin') {
            $articles = auth()->user()->articles();
        } else {
            $articles = Article::where('state', 'published');
        }
        $articles = $articles->whereNull('parent_id')->with('user')->orderBy('created_at', 'desc')->paginate($perpage_cnt);

        // 統計留言數量
        $cnt_arr = array();
        if (count( $articles->pluck('id') ) > 0) {
            $cnt_arr = Article::select('parent_id', DB::raw('COUNT(id) AS count'))
                ->whereIn('parent_id', $articles->pluck('id') )
                ->groupBy('parent_id')->get()->keyBy('parent_id')->toArray();
        }

        return view('articles.index', ['articles'=>$articles, 'cnt_arr'=>$cnt_arr]);
    }

    public function show($id) {
        if ( $article = Article::where('id', $id)->whereNull('parent_id')->first()) {
            if ( ($article->state == 'published') || 
                 (Auth::check() && ($article->user_id == Auth::user()->id)) ) {
                $comment_articles = Article::where('state', 'published')->where('parent_id', $id)->with('user')->get();

                return view('articles.show', ['article'=>$article, 'comment_articles'=>$comment_articles]);
            } else {
                return view('articles.autherr', ['errmsg'=>'未經授權處理']);
            }    
        } else {
            return view('articles.autherr', ['errmsg'=>'查無資料']);
        }
    }

    public function create() {
        return view('articles.create');
    }

    public function store(Request $request) {
        $r = new ArticleRequest;

        if (is_null($request->get('parent_id'))) {
            $data = $request->validate($r->rules(), $r->messages(), $r->attributes());
            auth()->user()->articles()->create($data);
    
            return $this->redirect_list('文章新增完成!');
        } else {
            // 留言文章
            $parent_id = $request->get('parent_id');

            $rules = ['content'=>'required','parent_id'=>'required'];
            $attributes = ['content'=>'留言內容'];
    
            $data = $request->validate($rules, $r->messages(), $attributes);
            $data['state'] = 'published';
            auth()->user()->articles()->create($data);

            return redirect()->route('articles.show', ['article' => $parent_id])->with('notice', '留言完成!');
        }
    }

    public function edit(Request $request, $id) {
        if ($article = auth()->user()->articles()->find($id)) {
            return view('articles.edit', ['article'=>$article]);
        } else {
            return view('articles.autherr', ['errmsg'=>'未經授權處理']);
        }
    }

    public function update(ArticleRequest $request, $id) {
        if ($article = auth()->user()->articles()->find($id)) {
            $article->update( $request->all() );

            return $this->redirect_list('文章更新完成!');
        } else {
            return view('articles.autherr', ['errmsg'=>'未經授權處理']);
        }
    }

    public function destroy(Request $request, $id) {
        if ($article = auth()->user()->articles()->find($id)) {
            $article->delete();

            if ($request->get('comment') == 1) {
                // 刪除留言
                $parent_id = $article->parent_id;
                return redirect()->route('articles.show', ['article' => $parent_id])->with('notice', '留言已刪除!');
            } else {
                return $this->redirect_list('文章已刪除!');
            }
        } else {
            return view('articles.autherr', ['errmsg'=>'未經授權處理']);
        }
    }

    public function redirect_list($notice) {
        if ( session()->has('redirect_url') ) {
            return redirect( session()->pull('redirect_url') )->with('notice', $notice);
        } else {
            return redirect()->route('articles')->with('notice', $notice);
        }
    }
}

app/Http/Livewire/Articles/Create.php
<?php

namespace App\Http\Livewire\Articles;

use Livewire\Component;

class Create extends Component
{
    public function render()
    {
        return view('livewire.articles.create');
    }
}

app/Http/Livewire/Articles/Edit.php
<?php

namespace App\Http\Livewire\Articles;

use Livewire\Component;

class Edit extends Component
{
    public $article_id;

    public function mount($id) {
        $this->article_id = $id;
    }

    public function render()
    {
        return view('livewire.articles.edit');
    }
}

app/Http/Livewire/Articles/Form.php
<?php

namespace App\Http\Livewire\Articles;

use Livewire\Component;
use App\Models\Article;
use App\Http\Requests\ArticleRequest;

class Form extends Component
{
    public $article_id;
    public $title;
    public $content;
    public $state = 'published';

    public function mount($article_id = null) {
        $this->article_id = $article_id;

        if ( $this->article_id ) {
            if ( $article = Article::find($this->article_id) ) {
                $this->article_id = $article->id;
                $this->title = $article->title;
                $this->content = $article->content;
                $this->state = $article->state;
            }
        }
    }

    public function render()
    {
        if ( $this->article_id ) {
            // 編輯文章：權限檢查
            if (auth()->user()->articles()->find($this->article_id)) {
                return view('livewire.articles.form');
            } else {
                return view('livewire.systemerr', ['errmsg'=>'未經授權處理']);
            }
        } else {
            // 新增文章
            return view('livewire.articles.form');
        }
    }

    public function submit() {
        $r = new ArticleRequest;

        $data = $this->validate($r->rules(), $r->messages(), $r->attributes());

        if ( $this->article_id ) {
            // 編輯文章：權限檢查
            if ($article = auth()->user()->articles()->find( $this->article_id )) {
                $article->update( $data );
    
                return $this->redirect_list('文章更新完成!');
            } else {
                return $this->redirect_list('更新失敗，未經授權處理');
            }
        } else {
            // 新增文章
            auth()->user()->articles()->create($data);
            return $this->redirect_list('文章新增完成!');
        }
    }

    public function redirect_list($notice) {
        if ( session()->has('redirect_url') ) {
            return redirect( session()->pull('redirect_url') )->with('notice', $notice);
        } else {
            return redirect()->route('lw.articles')->with('notice', $notice);
        }
    }
}

app/Http/Livewire/Articles/Index.php
<?php

namespace App\Http\Livewire\Articles;

use Illuminate\Support\Facades\DB;
use Livewire\Component;
use Illuminate\Http\Request;
use App\Models\Article;

class Index extends Component
{
    public $is_admin = false;

    protected $listeners = ['article_destroy'];

    public function mount() {
        session( ['redirect_url' => url()->current()] );
    }

    public function render(Request $request)
    {
        $perpage_cnt = 10;

        if ( preg_match('/\/articles\/admin$/', session()->get('redirect_url')) ) {
            $this->is_admin = true;
            $articles = auth()->user()->articles();
        } else {
            $articles = Article::where('state', 'published');
        }
        $articles = $articles->whereNull('parent_id')->with('user')->orderBy('created_at', 'desc')->paginate($perpage_cnt);

        // 統計留言數量
        $cnt_arr = array();
        if (count( $articles->pluck('id') ) > 0) {
            $cnt_arr = Article::select('parent_id', DB::raw('COUNT(id) AS count'))
                ->whereIn('parent_id', $articles->pluck('id') )
                ->groupBy('parent_id')->get()->keyBy('parent_id')->toArray();
        }

        return view('livewire.articles.index', ['articles'=>$articles, 'cnt_arr'=>$cnt_arr]);

    }

    public function article_destroy($article_id) {
        if ($article = auth()->user()->articles()->find($article_id)) {
            $article->delete();

            session(['notice' => '文章已刪除!']);
        } else {
            session(['notice' => '刪除失敗，未經授權處理']);
        }        
        return true;
    }
}

app/Http/Livewire/Articles/Show.php
<?php

namespace App\Http\Livewire\Articles;

use Livewire\Component;
use Illuminate\Support\Facades\Auth;
use App\Models\Article;
use App\Http\Requests\ArticleRequest;

class Show extends Component
{
    public $is_admin = false;
    public $article_id;
    public $parent_id;
    public $content;

    protected $listeners = ['common_destroy'];

    public function mount($id) {
        $this->article_id = $id;
        $this->parent_id = $id;
    }

    public function render()
    {
        $this->is_admin = preg_match('/\/articles\/admin$/', session()->get('redirect_url')) ? true : false;

        if ( $article = Article::where('id', $this->article_id)->whereNull('parent_id')->first()) {
            if ( ($article->state == 'published') || 
                 (Auth::check() && ($article->user_id == Auth::user()->id)) ) {
                $comments = Article::where('state', 'published')->where('parent_id', $this->article_id)->with('user')->get();

                return view('livewire.articles.show', ['article'=>$article, 'comments'=>$comments]);
            } else {
                return view('livewire.systemerr_extends', ['errmsg'=>'未經授權處理']);
            }  
        } else {
            return view('livewire.systemerr_extends', ['errmsg'=>'查無資料']);
        }
    }

    // 新增留言
    public function store() {
        $r = new ArticleRequest;

        $rules = ['content'=>'required','parent_id'=>'required'];
        $attributes = ['content'=>'留言內容'];

        $data = $this->validate($rules, $r->messages(), $attributes);
        $data['state'] = 'published';
        auth()->user()->articles()->create($data);

        $this->content = null;
        session(['notice' => '留言完成!']);

        return true;
    }

    // 刪除留言
    public function common_destroy($common_id) {
        if ($article = auth()->user()->articles()->find($common_id)) {
            $article->delete();

            session(['notice' => '留言已刪除!']);
        } else {
            session(['notice' => '刪除失敗，未經授權處理']);
        }

        return true;
    }
}

resources/views/articles/autherr.blade.php
@extends('layouts.article')

@push('main')
    <div class="text-2xl font-medium text-white bg-red-500">錯誤訊息</div>
    <hr class="mb-4">

    <div class="text-2xl text-red-600 mt-2 text-center">{{ $errmsg }}</div>

    <div class="flex justify-center py-4 mt-6">
        <button type="button" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white uppercase tracking-widest hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2" onclick="history.back()">回上一頁</button>
    </div>
@endpush

resources/views/articles/create.blade.php
@extends('layouts.article')

@push('function_path')
    &gt; 新增文章
@endpush

@push('main')
<div class="flex justify-center py-4">
    <form action="{{ route('articles.store') }}" method="post">
        @csrf
        <div class="flex field">
            <div class="mt-2 mr-2 font-semibold nowrap">標題</div>
            <div class="w-full">
                <input type="text" value="{{ old('title') }}" name="title" class="border border-gray-300 p-2 w-full">
                <div class="text-sm text-red-600 mt-2 ml-2">
                @error('title')
                    {{ $message }}
                @enderror
                </div>
            </div>
        </div>
        <div class="flex field mt-4">
            <div class="mt-2 mr-2 font-semibold nowrap">內文</div>
            <div class="w-full">
                <textarea name="content" cols="60" rows="12" class="border border-gray-300 p-2">{{ old('content') }}</textarea>
                <div class="text-sm text-red-600 mt-2 ml-2">
                @error('content')
                    {{ $message }}
                @enderror
                </div>
            </div>
        </div>
        <div class="flex field mt-4">
            <div class="mr-2 font-semibold">狀態</div>
            <div>
                <input type="radio" value="draft" name="state" @if( old('state') == 'draft' ) checked @endif> 草稿
                <input type="radio" value="private" name="state" @if( old('state') == 'private' ) checked @endif> 不公開
                <input type="radio" value="published" name="state" @if( old('state') == '' || old('state') == 'published' ) checked @endif> 發佈
            </div>
        </div>
        <div class="flex justify-center py-4 mt-6">
            <button type="button" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white uppercase tracking-widest hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2" onclick="history.back()">回上一頁</button>
            <button type="submit" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white uppercase tracking-widest hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2">確定</button>
        </div>
    </form>
</div>
@endpush

resources/views/articles/edit.blade.php
@extends('layouts.article')

@push('function_path')
    &gt; 編輯文章
@endpush

@push('main')
<div class="flex justify-center py-4">
    <form action="{{ route('articles.update', $article) }}" method="post">
        @csrf
        @method('PUT')
        <div class="flex field">
            <div class="mt-2 mr-2 font-semibold nowrap">標題</div>
            <div class="w-full">
                <input type="text" value="{{ old('title', $article->title) }}" name="title" class="border border-gray-300 p-2 w-full">
                <div class="text-sm text-red-600 mt-2 ml-2">
                @error('title')
                    {{ $message }}
                @enderror
                </div>
            </div>
        </div>
        <div class="flex field mt-4">
            <div class="mt-2 mr-2 font-semibold nowrap">內文</div>
            <div class="w-full">
                <textarea name="content" cols="60" rows="12" class="border border-gray-300 p-2">{{ old('content', $article->content) }}</textarea>
                <div class="text-sm text-red-600 mt-2 ml-2">
                @error('content')
                    {{ $message }}
                @enderror
                </div>
            </div>
        </div>
        <div class="flex field mt-4">
            <div class="mr-2 font-semibold">狀態</div>
            <div>
            <input type="radio" value="draft" name="state" @if( old('state', $article->state) == 'draft' ) checked @endif> 草稿
                <input type="radio" value="private" name="state" @if( old('state', $article->state) == 'private' ) checked @endif> 不公開
                <input type="radio" value="published" name="state" @if( old('state', $article->state) == 'published' ) checked @endif> 發佈
            </div>
        </div>

        <div class="flex justify-center py-4 mt-6">
            <button type="button" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white uppercase tracking-widest hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2" onclick="history.back()">回上一頁</button>
            <button type="submit" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white uppercase tracking-widest hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2">確定</button>
        </div>
    </form>
</div>
@endpush

resources/views/articles/index.blade.php
@extends('layouts.article')

@php
    $admin_flag = (Request::getRequestUri() == '/articles/admin') ? true : false;
@endphp

@push('function_path')
    @if($admin_flag)
        &gt; <a href="{{ route('articles.admin') }}" class="hover:text-gray-400 dark:hover:text-white">我的文章</a>
    @endif
@endpush

@push('main')
    @foreach($articles as $article)
    <p class="ml-3 mt-4 text-2xl font-semibold text-indigo-600 hover:text-indigo-400 dark:hover:text-white">
        <a href="{{ route('articles.show', $article) }}">{{ $article->title }}</a>
    </p>
    <div class="border-b border-gray-200">
        <div class="grid-cols-2">
            <div class="ml-3 mt-3 flex">
                {{ $article->updated_at->format('Y-m-d') }} ‧ 
                由 <div class="text-green-600 mx-2">{{ $article->user->name }}</div> 分享
                @if ($admin_flag)
                    <img src="/images/{{ $article->state }}.png" class="ml-4">
                @endif
                <div class="mx-2">
                    留言( {{ $cnt_arr[$article->id]['count'] ?? 0 }} )
                </div>
            </div>

            @auth
            @if ( auth()->user()->id == $article->user_id )
            <div class="text-right mb-2">
                <a href="{{ route('articles.edit', $article) }}" class="mr-1 text-sm px-4 py-2 bg-gray-500 border rounded-md text-white hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900">編輯</a>
                <form action="{{ route('articles.destroy', $article) }}" onsubmit="return confirm('是否確定刪除?');" method="post" class="inline-flex">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="mr-1 text-sm px-4 py-2 bg-gray-500 border rounded-md text-white hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900">刪除</button>
                </form>
            </div>
            @endif
            @endauth        
        </div>
    </div>
    @endforeach

    <div class="mt-8 ml-3 mr-3">{{ $articles->links() }}</div>
@endpush

resources/views/articles/show.blade.php
@extends('layouts.article')

@php
    $admin_flag = preg_match("/(\/articles\/admin(\/)?$)/i",session()->get('redirect_url')) ? true : false;
@endphp

@push('function_path')
    @if($admin_flag)
        &gt; <a href="{{ route('articles.admin') }}" class="hover:text-gray-400 dark:hover:text-white">我的文章</a>
    @endif
@endpush

@push('main')
<div class="mx-6 mb-3">
    <div class="grid-cols-2 mt-4">
        <div class="text-2xl font-semibold text-indigo-600">
            {{ $article->title }}
        </div>
        <div class="text-right">
        @auth
            @if ( auth()->user()->id == $article->user_id )
                <a href="{{ route('articles.edit', $article) }}" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900">編輯</a>
            @endif
        @endauth
                <button type="button" class="mr-1 text-sm px-4 py-2 bg-gray-500 border border-transparent rounded-md text-white hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900" onclick="history.back()">回上一頁</button>
        </div>
    </div>
    <div class="mt-3 inline-flex">
        <div class="text-green-600 mx-2">{{ $article->user->name }}</div>  - 
        <div class="text-gray-500 mx-2">{{ $article->updated_at }} 最後更新</div> 
    </div>
    <hr>
    <div class="mt-3 mx-2 text-lg">
        {!! html_entity_decode(nl2br($article->content)) !!}
    </div>
    @auth
        <div class="mt-3 bg-gray-200 py-3 rounded">
            <form action="{{ route('articles.store') }}" method="post">
                @csrf
                <input type="hidden" name="parent_id" value="{{ $article->id }}">
                <div class="mx-2 text-lg inline-flex">
                    <div class="text-lg inline-flex">
                        <div class="mr-2 text-green-600">{{ Auth::user()->name }}</div> 留言：
                        <textarea name="content" cols="60" rows="5" class="border border-gray-300 p-2 rounded-md">{{ old('content') }}</textarea>
                    </div>
                    <div class="ml-2 relative w-60">
                        <div class="text-sm text-red-600 mt-2 ml-2">
                            @error('content')
                                {{ $message }}
                            @enderror
                        </div>
                        <div class="pb-0">
                            <button type="submit" class="text-sm px-4 py-2 bg-gray-500 rounded-md text-white hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900">送出</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    @endauth
</div>
@endpush

@push('sub_main')
    <div class="bg-white overflow-hidden shadow-xl sm:rounded-lg">
    @foreach($comment_articles as $article)
        <div class="mx-6 mt-3 inline-flex w-full">
            <div><img src="/images/comment.png"></div>
            <div class="mx-2 w-eighty">
                <div class="inline-flex">
                    <div class="text-green-600">{{ $article->user->name }}</div>  - 
                    <div class="text-gray-500 mx-2">{{ $article->created_at }} 留言</div> 
                </div>
                <div class="mt-2 px-2 py-2 text-lg bg-gray-200 rounded w-full">
                    <pre>{{ $article->content }}</pre>
                </div>
            </div>

            @auth
            @if ( auth()->user()->id == $article->user_id )
            <div class="relative w-20">
                <div class="pb-0">
                    <form action="{{ route('articles.destroy', $article) }}" method="post" class="inline-flex">
                        @csrf
                        @method('DELETE')
                        <input type="hidden" name="comment" value="1">
                        <button type="submit" class="mr-1 text-sm px-4 py-2 bg-gray-500 border rounded-md text-white hover:bg-gray-700 focus:bg-gray-700 active:bg-gray-900">刪除</button>
                    </form>
                </div>
            </div>
            @endif
            @endauth        


        </div>
    @endforeach
    </div>
@endpush